## ros-opencv-apps 1.11.14

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 2.8.3)
project(opencv_apps)

find_package(catkin REQUIRED COMPONENTS cv_bridge dynamic_reconfigure message_generation image_transport nodelet roscpp)

find_package(OpenCV REQUIRED)
message(STATUS "OpenCV Components: ${OpenCV_LIB_COMPONENTS}")
if(OpenCV_VERSION VERSION_LESS "3.0" OR TARGET opencv_optflow)
  set(OPENCV_HAVE_OPTFLOW TRUE)
endif()
# Supporting CompressedImage in cv_bridge has been started from 1.11.9 (2015-11-29)
# note : hydro 1.10.18, indigo : 1.11.13 ...
# https://github.com/ros-perception/vision_opencv/pull/70
if(cv_bridge_VERSION VERSION_LESS "1.11.9")
  add_definitions("-DCV_BRIDGE_COMPRESSED_IMAGE_IS_NOT_SUPPORTED")
endif()

# generate the dynamic_reconfigure config file
generate_dynamic_reconfigure_options(
  cfg/AddingImages.cfg
  cfg/Smoothing.cfg
  cfg/EdgeDetection.cfg cfg/HoughLines.cfg cfg/HoughCircles.cfg
  cfg/FindContours.cfg cfg/ConvexHull.cfg cfg/GeneralContours.cfg cfg/ContourMoments.cfg
  cfg/FaceDetection.cfg
  cfg/GoodfeatureTrack.cfg
  #
  cfg/CamShift.cfg
  cfg/FBackFlow.cfg
  cfg/LKFlow.cfg
  cfg/PeopleDetect.cfg
  cfg/PhaseCorr.cfg
  cfg/SegmentObjects.cfg
  cfg/SimpleFlow.cfg
  cfg/Threshold.cfg
  cfg/WatershedSegmentation.cfg
  )

## Generate messages in the 'msg' folder
add_message_files(
   FILES
   Point2D.msg
   Point2DStamped.msg
   Point2DArray.msg
   Point2DArrayStamped.msg
   Rect.msg
   RectArray.msg
   RectArrayStamped.msg
   Flow.msg
   FlowStamped.msg
   FlowArray.msg
   FlowArrayStamped.msg
   RectArrayStamped.msg
   Size.msg
   Face.msg
   FaceArray.msg
   FaceArrayStamped.msg
   Line.msg
   LineArray.msg
   LineArrayStamped.msg
   RotatedRect.msg
   RotatedRectStamped.msg
   RotatedRectArray.msg
   RotatedRectArrayStamped.msg
   Circle.msg
   CircleArray.msg
   CircleArrayStamped.msg
   Moment.msg
   MomentArray.msg
   MomentArrayStamped.msg
   Contour.msg
   ContourArray.msg
   ContourArrayStamped.msg
)

## Generate added messages and services with any dependencies listed here
generate_messages(
  DEPENDENCIES
  std_msgs
)

catkin_package(CATKIN_DEPENDS std_msgs
#                DEPENDS OpenCV
               INCLUDE_DIRS include
               LIBRARIES ${PROJECT_NAME}
)

include_directories(include ${catkin_INCLUDE_DIRS} ${OpenCV_INCLUDE_DIRS})

## Declare a cpp library
if(OPENCV_HAVE_OPTFLOW)
  list(APPEND ${PROJECT_NAME}_EXTRA_FILES src/nodelet/simple_flow_nodelet.cpp)
endif()

## Macro to add nodelets
macro(opencv_apps_add_nodelet node_name nodelet_name nodelet_cppfile)
  set(NODE_NAME ${node_name})
  set(NODELET_NAME ${nodelet_name})
  configure_file(src/node/standalone_nodelet_exec.cpp.in ${node_name}.cpp @ONLY)
  add_executable(${node_name}_exe ${node_name}.cpp)
  SET_TARGET_PROPERTIES(${node_name}_exe PROPERTIES OUTPUT_NAME ${node_name})
  target_link_libraries(${node_name}_exe ${catkin_LIBRARIES} ${OpenCV_LIBRARIES})
  list(APPEND _opencv_apps_nodelet_cppfiles ${nodelet_cppfile})
  list(APPEND _opencv_apps_nodelet_targets ${node_name}_exe)
endmacro()

# https://github.com/Itseez/opencv/blob/2.4/samples/cpp/

# calib3d
  # ./tutorial_code/calib3d/camera_calibration/camera_calibration.cpp
  # ./tutorial_code/calib3d/real_time_pose_estimation/src/main_detection.cpp
  # ./tutorial_code/calib3d/real_time_pose_estimation/src/main_registration.cpp
  # ./tutorial_code/calib3d/stereoBM/SBM_Sample.cpp

# core
opencv_apps_add_nodelet(adding_images adding_images/adding_images src/nodelet/adding_images_nodelet.cpp) # ./tutorial_code/core/AddingImages/AddingImages.cpp
  # ./tutorial_code/core/discrete_fourier_transform/discrete_fourier_transform.cpp
  # ./tutorial_code/core/file_input_output/file_input_output.cpp
  # ./tutorial_code/core/how_to_scan_images/how_to_scan_images.cpp
  # ./tutorial_code/core/interoperability_with_OpenCV_1/interoperability_with_OpenCV_1.cpp
  # ./tutorial_code/core/ippasync/ippasync_sample.cpp
  # ./tutorial_code/core/mat_mask_operations/mat_mask_operations.cpp
  # ./tutorial_code/core/Matrix/Drawing_1.cpp
  # ./tutorial_code/core/Matrix/Drawing_2.cpp
  # ./tutorial_code/core/mat_the_basic_image_container/mat_the_basic_image_container.cpp

# features2D
  # ./tutorial_code/features2D/AKAZE_match.cpp
  # ./tutorial_code/features2D/AKAZE_tracking/planar_tracking.cpp
  # ./tutorial_code/gpu/gpu-basics-similarity/gpu-basics-similarity.cpp

# highGUi
  # ./tutorial_code/HighGUI/AddingImagesTrackbar.cpp
  # ./tutorial_code/HighGUI/BasicLinearTransformsTrackbar.cpp

# Histograms_Matching
  # ./tutorial_code/Histograms_Matching/calcBackProject_Demo1.cpp
  # ./tutorial_code/Histograms_Matching/calcBackProject_Demo2.cpp
  # ./tutorial_code/Histograms_Matching/calcHist_Demo.cpp
  #  ./tutorial_code/Histograms_Matching/compareHist_Demo.cpp
  # ./tutorial_code/Histograms_Matching/EqualizeHist_Demo.cpp
  # ./tutorial_code/Histograms_Matching/MatchTemplate_Demo.cpp

# imagecodecs
  # ./tutorial_code/imgcodecs/GDAL_IO/gdal-image.cpp

# ImgProc
  # ./tutorial_code/ImgProc/BasicLinearTransforms.cpp
  # ./tutorial_code/ImgProc/Morphology_1.cpp
  # ./tutorial_code/ImgProc/Morphology_2.cpp
  # ./tutorial_code/ImgProc/Morphology_3.cpp
  # ./tutorial_code/ImgProc/Pyramids.cpp
opencv_apps_add_nodelet(smoothing smoothing/smoothing src/nodelet/smoothing_nodelet.cpp)  # ./tutorial_code/ImgProc/Smoothing.cpp
opencv_apps_add_nodelet(threshold threshold/threshold src/nodelet/threshold_nodelet.cpp)  # ./tutorial_code/ImgProc/Threshold.cpp
  # ./tutorial_code/ImgProc/Threshold_inRange.cpp

# ImgTrans
opencv_apps_add_nodelet(edge_detection edge_detection/edge_detection src/nodelet/edge_detection_nodelet.cpp) # ./tutorial_code/ImgTrans/CannyDetector_Demo.cpp
                                                                                                             # ./tutorial_code/ImgTrans/Laplace_Demo.cpp
                                                                                                             # ./tutorial_code/ImgTrans/Sobel_Demo.cpp
opencv_apps_add_nodelet(hough_lines hough_lines/hough_lines src/nodelet/hough_lines_nodelet.cpp) # ./tutorial_code/ImgTrans/HoughLines_Demo.cpp
opencv_apps_add_nodelet(hough_circles hough_circles/hough_circles src/nodelet/hough_circles_nodelet.cpp) # ./tutorial_code/ImgTrans/HoughCircle_Demo.cpp
 # ./tutorial_code/ImgTrans/copyMakeBorder_demo.cpp
 # ./tutorial_code/ImgTrans/filter2D_demo.cpp
 # ./tutorial_code/ImgTrans/Geometric_Transforms_Demo.cpp
 # ./tutorial_code/ImgTrans/imageSegmentation.cpp
 # ./tutorial_code/ImgTrans/Remap_Demo.cpp

# introduction
 # ./tutorial_code/introduction/display_image/display_image.cpp
 # ./tutorial_code/introduction/windows_visual_studio_Opencv/introduction_windows_vs.cpp

# ml
 # ./tutorial_code/ml/introduction_to_pca/introduction_to_pca.cpp
 # ./tutorial_code/ml/introduction_to_svm/introduction_to_svm.cpp
 # ./tutorial_code/ml/non_linear_svms/non_linear_svms.cpp

# objectDetection
 # ./tutorial_code/objectDetection/objectDetection2.cpp
 # ./tutorial_code/objectDetection/objectDetection.cpp

# photo
 # ./tutorial_code/photo/decolorization/decolor.cpp
 # ./tutorial_code/photo/hdr_imaging/hdr_imaging.cpp
 # ./tutorial_code/photo/non_photorealistic_rendering/npr_demo.cpp
 # ./tutorial_code/photo/seamless_cloning/cloning_demo.cpp
 # ./tutorial_code/photo/seamless_cloning/cloning_gui.cpp

# ShapeDescriptors
opencv_apps_add_nodelet(find_contours find_contours/find_contours src/nodelet/find_contours_nodelet.cpp) # ./tutorial_code/ShapeDescriptors/findContours_demo.cpp
opencv_apps_add_nodelet(convex_hull convex_hull/convex_hull src/nodelet/convex_hull_nodelet.cpp) # ./tutorial_code/ShapeDescriptors/hull_demo.cpp
opencv_apps_add_nodelet(general_contours general_contours/general_contours src/nodelet/general_contours_nodelet.cpp) # ./tutorial_code/ShapeDescriptors/generalContours_demo2.cpp
opencv_apps_add_nodelet(contour_moments contour_moments/contour_moments src/nodelet/contour_moments_nodelet.cpp) # ./tutorial_code/ShapeDescriptors/moments_demo.cpp
  # ./tutorial_code/ShapeDescriptors/generalContours_demo1.cpp
  # ./tutorial_code/ShapeDescriptors/pointPolygonTest_demo.cpp

# TrackingMotion
opencv_apps_add_nodelet(goodfeature_track goodfeature_track/goodfeature_track src/nodelet/goodfeature_track_nodelet.cpp) # ./tutorial_code/TrackingMotion/goodFeaturesToTrack_Demo.cpp
  # ./tutorial_code/TrackingMotion/cornerDetector_Demo.cpp
  # ./tutorial_code/TrackingMotion/cornerHarris_Demo.cpp
  # ./tutorial_code/TrackingMotion/cornerSubPix_Demo.cpp

# videoio
 # ./tutorial_code/video/bg_sub.cpp
 # ./tutorial_code/videoio/video-input-psnr-ssim/video-input-psnr-ssim.cpp
 # ./tutorial_code/videoio/video-write/video-write.cpp

# viz
 # ./tutorial_code/viz/creating_widgets.cpp
 # ./tutorial_code/viz/launching_viz.cpp
 # ./tutorial_code/viz/transformations.cpp
 # ./tutorial_code/viz/widget_pose.cpp

# xfeature
 # ./tutorial_code/xfeatures2D/LATCH_match.cpp

# ./3calibration.cpp
# ./autofocus.cpp
# ./bgfg_segm.cpp
# ./calibration.cpp
opencv_apps_add_nodelet(camshift camshift/camshift src/nodelet/camshift_nodelet.cpp) # ./camshiftdemo.cpp
# ./cloning_demo.cpp
# ./cloning_gui.cpp
# ./connected_components.cpp
# ./contours2.cpp
# ./convexhull.cpp
# ./cout_mat.cpp
# ./create_mask.cpp
# ./dbt_face_detection.cpp
# ./delaunay2.cpp
# ./demhist.cpp
# ./detect_blob.cpp
# ./detect_mser.cpp
# ./dft.cpp
# ./distrans.cpp
# ./drawing.cpp
# ./edge.cpp
# ./em.cpp
# ./example_cmake/example.cpp
opencv_apps_add_nodelet(face_detection face_detection/face_detection src/nodelet/face_detection_nodelet.cpp) # ./facedetect.cpp
# ./facial_features.cpp
opencv_apps_add_nodelet(fback_flow fback_flow/fback_flow src/nodelet/fback_flow_nodelet.cpp) # ./fback.cpp
# ./ffilldemo.cpp
# ./filestorage_base64.cpp
# ./filestorage.cpp
# ./fitellipse.cpp
# ./grabcut.cpp
# ./houghcircles.cpp
# ./houghlines.cpp
# ./image_alignment.cpp
# ./image.cpp
# ./imagelist_creator.cpp
# ./image_sequence.cpp
# ./inpaint.cpp
# ./intelperc_capture.cpp
# ./kalman.cpp
# ./kmeans.cpp
# ./laplace.cpp
# ./letter_recog.cpp
opencv_apps_add_nodelet(lk_flow lk_flow/lk_flow src/nodelet/lk_flow_nodelet.cpp) # ./lkdemo.cpp
# ./logistic_regression.cpp
# ./lsd_lines.cpp
# ./mask_tmpl.cpp
# ./matchmethod_orb_akaze_brisk.cpp
# ./minarea.cpp
# ./morphology2.cpp
# ./neural_network.cpp
# ./npr_demo.cpp
# ./opencv_version.cpp
# ./openni_capture.cpp
# ./pca.cpp
opencv_apps_add_nodelet(people_detect people_detect/people_detect src/nodelet/people_detect_nodelet.cpp) # ./peopledetect.cpp
opencv_apps_add_nodelet(phase_corr phase_corr/phase_corr src/nodelet/phase_corr_nodelet.cpp) # ./phase_corr.cpp
# ./points_classifier.cpp
# ./polar_transforms.cpp
opencv_apps_add_nodelet(segment_objects segment_objects/segment_objects src/nodelet/segment_objects_nodelet.cpp) # ./segment_objects.cpp
# ./select3dobj.cpp
# ./shape_example.cpp
# ./smiledetect.cpp
# ./squares.cpp
# ./starter_imagelist.cpp
# ./starter_video.cpp
# ./stereo_calib.cpp
# ./stereo_match.cpp
# ./stitching.cpp
# ./stitching_detailed.cpp
# ./train_HOG.cpp
# ./train_svmsgd.cpp
# ./tree_engine.cpp
# ./tvl1_optical_flow.cpp
# ./videostab.cpp
opencv_apps_add_nodelet(watershed_segmentation watershed_segmentation/watershed_segmentation src/nodelet/watershed_segmentation_nodelet.cpp) # ./watershed.cpp

# ros examples
opencv_apps_add_nodelet(simple_example simple_example/simple_example src/nodelet/simple_example_nodelet.cpp)
opencv_apps_add_nodelet(simple_compressed_example simple_compressed_example/simple_compressed_example src/nodelet/simple_compressed_example_nodelet.cpp)

# https://github.com/Itseez/opencv/blob/2.4/samples/cpp/simpleflow_demo.cpp
# simple flow requires opencv-contrib https://github.com/ros-perception/vision_opencv/issues/108
if(OPENCV_HAVE_OPTFLOW)
  opencv_apps_add_nodelet(simple_flow simple_flow/simple_flow src/nodelet/simple_flow_nodelet.cpp)
endif()
# https://github.com/opencv/opencv/blob/2.4/samples/cpp/bgfg_gmg.cpp
# https://github.com/opencv/opencv/blob/2.4/samples/cpp/hybridtrackingsample.cpp

=== test/CMakeLists.txt ===
# Tests simple calibration dataset
catkin_download_test_data(face_detector_withface_test_diamondback.bag http://download.ros.org/data/face_detector/face_detector_withface_test_diamondback.bag
  DESTINATION ${CMAKE_CURRENT_SOURCE_DIR}
  MD5 59126117e049e69d577b7ee27251a6f8
  )
catkin_download_test_data(vslam_tutorial.bag http://download.ros.org/data/vslam_system/vslam_tutorial.bag
  DESTINATION ${CMAKE_CURRENT_BINARY_DIR}
  MD5 f5aece448b7af00a38a993eb71400806
  )
add_custom_command(OUTPUT ${CMAKE_CURRENT_SOURCE_DIR}/vslam_tutorial.bag
  DEPENDS vslam_tutorial.bag
  COMMAND rosbag reindex vslam_tutorial.bag --output-dir ${CMAKE_CURRENT_SOURCE_DIR}
)
add_custom_target(vslam_tutorial_bag DEPENDS ${CMAKE_CURRENT_SOURCE_DIR}/vslam_tutorial.bag)
add_dependencies(tests vslam_tutorial_bag)

#add_rostest(test-apps.test)
add_rostest(test-adding_images.test ARGS gui:=false)
add_rostest(test-smoothing.test ARGS gui:=false)
add_rostest(test-threshold.test ARGS gui:=false)
add_rostest(test-edge_detection.test ARGS gui:=false)

add_rostest(test-hough_lines.test ARGS gui:=false)
add_rostest(test-hough_circles.test ARGS gui:=false)
add_rostest(test-find_contours.test ARGS gui:=false)
add_rostest(test-convex_hull.test ARGS gui:=false)
add_rostest(test-general_contours.test ARGS gui:=false)
add_rostest(test-contour_moments.test ARGS gui:=false)
if(OpenCV_VERSION VERSION_LESS "3.0")
  add_rostest(test-face_detection.test ARGS gui:=false)
else()
  add_rostest(test-face_detection.test ARGS gui:=false use_opencv3:=true)
endif()
add_rostest(test-goodfeature_track.test ARGS gui:=false)
add_rostest(test-camshift.test ARGS gui:=false)
add_rostest(test-fback_flow.test ARGS gui:=false)
add_rostest(test-lk_flow.test ARGS gui:=false)
add_rostest(test-people_detect.test ARGS gui:=false)
add_rostest(test-phase_corr.test ARGS gui:=false)
add_rostest(test-segment_objects.test ARGS gui:=false)
# simple flow requires opencv-contrib https://github.com/ros-perception/vision_opencv/issues/108
if(OPENCV_HAVE_OPTFLOW)
  add_rostest(test-simple_flow.test ARGS gui:=false)
endif()
add_rostest(test-watershed_segmentation.test ARGS gui:=false)

add_rostest(test-simple_example.test ARGS gui:=false)
add_rostest(test-simple_compressed_example.test ARGS gui:=false)

if(roslaunch_VERSION VERSION_LESS "1.11.1")
  message(WARNING "roslaunch_add_file check fails with unsupported doc attributes ${roslaunch_VERSION}")
else()
  file(GLOB LAUNCH_FILES *.test)
  foreach(LAUNCH_FILE ${LAUNCH_FILES})
    roslaunch_add_file_check(${LAUNCH_FILE})
  endforeach()
endif()

=== debian/changelog ===
ros-opencv-apps (1.11.14-1build4) bionic; urgency=medium

  * No-change rebuild against libconsole-bridge0.4

 -- Steve Langasek <steve.langasek@ubuntu.com>  Fri, 02 Mar 2018 07:12:51 +0000

ros-opencv-apps (1.11.14-1build3) bionic; urgency=medium

  * No-change rebuild against OpenCV 3.2.

 -- Mattia Rizzolo <mapreri@ubuntu.com>  Sun, 29 Oct 2017 13:06:09 +0100

ros-opencv-apps (1.11.14-1build2) bionic; urgency=medium

  * No-change rebuild for boost soname change.

 -- Matthias Klose <doko@ubuntu.com>  Thu, 26 Oct 2017 19:53:01 +0000

ros-opencv-apps (1.11.14-1build1) artful; urgency=medium

  * No-change rebuild against OpenCV 3.1.

 -- Mattia Rizzolo <mapreri@ubuntu.com>  Tue, 20 Jun 2017 23:57:09 +0200

ros-opencv-apps (1.11.14-1) unstable; urgency=medium

  * New package split from ros-vision-opencv
  * Initial package. Closes: #849068

 -- Leopold Palomo-Avellaneda <leo@alaxarxa.net>  Sun, 23 Oct 2016 18:16:48 +0200

=== debian/control ===
Source: ros-opencv-apps
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
Uploaders: Jochen Sprickerhof <jspricke@debian.org>,
           Leopold Palomo-Avellaneda <leo@alaxarxa.net>
Build-Depends: debhelper (>= 9), catkin (>= 0.6.16-4), librosconsole-dev,
		libsensor-msgs-dev, libboost-python-dev, libopencv-dev,
		libdynamic-reconfigure-config-init-mutex-dev, ros-message-generation,
		libimage-transport-dev, libnodeletlib-dev, libroscpp-dev, python-numpy,
		python-dynamic-reconfigure, libstd-srvs-dev, dh-python, python,
		librostest-dev, ros-std-msgs, libcv-bridge-dev,
		python-roslaunch, python-rostest, python-rosunit,
		python-rosservice, python-rosbag 
Standards-Version: 3.9.8
Section: libs
Homepage: http://wiki.ros.org/opencv_apps
Vcs-Git: https://anonscm.debian.org/git/debian-science/packages/ros/ros-opencv-apps.git
Vcs-Browser: https://anonscm.debian.org/cgit/debian-science/packages/ros/ros-opencv-apps.git

Package: libopencv-apps-dev
Section: libdevel
Architecture: any
Depends: libopencv-apps0d (= ${binary:Version}), ${misc:Depends},
 libcv-bridge-dev, libdynamic-reconfigure-config-init-mutex-dev,
 ros-message-generation, libimage-transport-dev, libnodeletlib-dev,libroscpp-dev
Description: Opencv_apps Robot OS package - development files
 This package is part of Robot OS (ROS). It contains several ROS
 packages for working providing OpenCV functionalities in a simplest
 manner in ROS, i.e., running a launch file that corresponds to
 the functionality.
 .
 The package contains implementations for edge detection, structual analysis, 
 people/face detection, motion analysis and object segmentation.
 .
 It contains development files for the opencv_apps library.

Package: libopencv-apps0d
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Multi-Arch: same
Description: opencv_apps Robot OS package - runtime files
 This package is part of Robot OS (ROS). It contains several ROS
 packages for working providing OpenCV functionalities in a simplest
 manner in ROS, i.e., running a launch file that corresponds to
 the functionality.
 .
 The package contains implementations for edge detection, structual analysis, 
 people/face detection, motion analysis and object segmentation.
 .
 It contains the opencv_apps library itself.
 
Package: ros-opencv-apps
Section: utils
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: opencv_apps Robot OS package - apps
 This package is part of Robot OS (ROS). It contains several ROS
 packages for working providing OpenCV functionalities in a simplest
 manner in ROS, i.e., running a launch file that corresponds to
 the functionality.
 .
 The package contains implementations for edge detection, structual analysis, 
 people/face detection, motion analysis and object segmentation.
 .
 It contains the nodes and the ROS stuff of the opencv-apps.

Package: python-opencv-apps
Section: python
Architecture: all
Depends: ${python:Depends}, ${shlibs:Depends}, ${misc:Depends},python-genpy, python-std-msgs
Description: opencv_apps Robot OS package - Python bindings
 This package is part of Robot OS (ROS). It contains several ROS
 packages for working providing OpenCV functionalities in a simplest
 manner in ROS, i.e., running a launch file that corresponds to
 the functionality.
 .
 The package contains implementations for edge detection, structual analysis, 
 people/face detection, motion analysis and object segmentation.
 .
 It contains the Python bindings for the opencv_apps library.

Package: cl-opencv-apps
Section: lisp
Architecture: all
Depends: ${misc:Depends}
Description: opencv_apps Robot OS package - LISP bindings
 This package is part of Robot OS (ROS). It contains several ROS
 packages for working providing OpenCV functionalities in a simplest
 manner in ROS, i.e., running a launch file that corresponds to
 the functionality.
 .
 The package contains implementations for edge detection, structual analysis, 
 people/face detection, motion analysis and object segmentation.
 .
 It contains the LISP bindings for the opencv_apps library.

=== debian/rules ===
#!/usr/bin/make -f
DPKG_EXPORT_BUILDFLAGS = 1
include /usr/share/dpkg/default.mk

%:
	dh $@ --parallel --with=python2 --buildsystem=cmake

override_dh_auto_install:
	dh_auto_install
	dh_numpy

override_dh_auto_configure:
	dh_auto_configure -- -DCATKIN_ENABLE_TESTING:BOOL=OFF

get-orig-source:
	uscan --verbose --force-download

=== debian/watch ===
# Watch control file for uscan
# For GitHub projects you can use the tags page:
version=4

opts="filenamemangle=s%(?:.*?)?v?(\d[\d.]*)\.tar\.gz%opencv_apps-$1.tar.gz%" \
             https://github.com/ros-perception/opencv_apps/releases \
             (?:.*?/)?v?(\d[\d.]*)\.tar\.gz debian uupdate

## ros-opencv-apps 1.12.0

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,9 +1,10 @@
 cmake_minimum_required(VERSION 2.8.3)
 project(opencv_apps)
 
-find_package(catkin REQUIRED COMPONENTS cv_bridge dynamic_reconfigure message_generation image_transport nodelet roscpp)
+find_package(catkin REQUIRED COMPONENTS cv_bridge dynamic_reconfigure message_generation image_transport nodelet roscpp sensor_msgs)
 
 find_package(OpenCV REQUIRED)
+message(STATUS "OpenCV VERSION: ${OpenCV_VERSION}")
 message(STATUS "OpenCV Components: ${OpenCV_LIB_COMPONENTS}")
 if(OpenCV_VERSION VERSION_LESS "3.0" OR TARGET opencv_optflow)
   set(OPENCV_HAVE_OPTFLOW TRUE)
@@ -14,15 +15,26 @@
 if(cv_bridge_VERSION VERSION_LESS "1.11.9")
   add_definitions("-DCV_BRIDGE_COMPRESSED_IMAGE_IS_NOT_SUPPORTED")
 endif()
+# Supporting CvtColorForDisplay in cv_bridge has been started from 1.11.9 (2015-11-29)
+if(cv_bridge_VERSION VERSION_LESS "1.11.9")
+  add_definitions("-DCV_BRIDGE_CVT_COLOR_FOR_DISPLAY_IS_NOT_SUPPORTED")
+endif()
+# Supporting CvtColorForDisplayOptions in cv_bridge has been started from 1.11.13 (2016-07-11)
+if(cv_bridge_VERSION VERSION_LESS "1.11.13")
+  add_definitions("-DCV_BRIDGE_CVT_COLOR_FOR_DISPLAY_OPTION_IS_NOT_SUPPORTED")
+endif()
 
 # generate the dynamic_reconfigure config file
 generate_dynamic_reconfigure_options(
+  cfg/DiscreteFourierTransform.cfg
   cfg/AddingImages.cfg
   cfg/Smoothing.cfg
   cfg/EdgeDetection.cfg cfg/HoughLines.cfg cfg/HoughCircles.cfg
   cfg/FindContours.cfg cfg/ConvexHull.cfg cfg/GeneralContours.cfg cfg/ContourMoments.cfg
   cfg/FaceDetection.cfg
+  cfg/FaceRecognition.cfg
   cfg/GoodfeatureTrack.cfg
+  cfg/CornerHarris.cfg
   #
   cfg/CamShift.cfg
   cfg/FBackFlow.cfg
@@ -32,6 +44,9 @@
   cfg/SegmentObjects.cfg
   cfg/SimpleFlow.cfg
   cfg/Threshold.cfg
+  cfg/RGBColorFilter.cfg
+  cfg/HLSColorFilter.cfg
+  cfg/HSVColorFilter.cfg
   cfg/WatershedSegmentation.cfg
   )
 
@@ -49,7 +64,6 @@
    FlowStamped.msg
    FlowArray.msg
    FlowArrayStamped.msg
-   RectArrayStamped.msg
    Size.msg
    Face.msg
    FaceArray.msg
@@ -72,9 +86,15 @@
    ContourArrayStamped.msg
 )
 
+add_service_files(
+  FILES
+  FaceRecognitionTrain.srv
+)
+
 ## Generate added messages and services with any dependencies listed here
 generate_messages(
   DEPENDENCIES
+  sensor_msgs
   std_msgs
 )
 
@@ -113,7 +133,7 @@
 
 # core
 opencv_apps_add_nodelet(adding_images adding_images/adding_images src/nodelet/adding_images_nodelet.cpp) # ./tutorial_code/core/AddingImages/AddingImages.cpp
-  # ./tutorial_code/core/discrete_fourier_transform/discrete_fourier_transform.cpp
+opencv_apps_add_nodelet(discrete_fourier_transform discrete_fourier_transform/discrete_fourier_transform src/nodelet/discrete_fourier_transform_nodelet.cpp)  # ./tutorial_code/core/discrete_fourier_transform/discrete_fourier_transform.cpp
   # ./tutorial_code/core/file_input_output/file_input_output.cpp
   # ./tutorial_code/core/how_to_scan_images/how_to_scan_images.cpp
   # ./tutorial_code/core/interoperability_with_OpenCV_1/interoperability_with_OpenCV_1.cpp
@@ -151,7 +171,9 @@
   # ./tutorial_code/ImgProc/Pyramids.cpp
 opencv_apps_add_nodelet(smoothing smoothing/smoothing src/nodelet/smoothing_nodelet.cpp)  # ./tutorial_code/ImgProc/Smoothing.cpp
 opencv_apps_add_nodelet(threshold threshold/threshold src/nodelet/threshold_nodelet.cpp)  # ./tutorial_code/ImgProc/Threshold.cpp
-  # ./tutorial_code/ImgProc/Threshold_inRange.cpp
+opencv_apps_add_nodelet(rgb_color_filter rgb_color_filter/rgb_color_filter src/nodelet/color_filter_nodelet.cpp)  # ./tutorial_code/ImgProc/Threshold_inRange.cpp
+opencv_apps_add_nodelet(hls_color_filter hls_color_filter/hls_color_filter src/nodelet/color_filter_nodelet.cpp)  # ./tutorial_code/ImgProc/Threshold_inRange.cpp
+opencv_apps_add_nodelet(hsv_color_filter hsv_color_filter/hsv_color_filter src/nodelet/color_filter_nodelet.cpp)  # ./tutorial_code/ImgProc/Threshold_inRange.cpp
 
 # ImgTrans
 opencv_apps_add_nodelet(edge_detection edge_detection/edge_detection src/nodelet/edge_detection_nodelet.cpp) # ./tutorial_code/ImgTrans/CannyDetector_Demo.cpp
@@ -196,7 +218,7 @@
 # TrackingMotion
 opencv_apps_add_nodelet(goodfeature_track goodfeature_track/goodfeature_track src/nodelet/goodfeature_track_nodelet.cpp) # ./tutorial_code/TrackingMotion/goodFeaturesToTrack_Demo.cpp
   # ./tutorial_code/TrackingMotion/cornerDetector_Demo.cpp
-  # ./tutorial_code/TrackingMotion/cornerHarris_Demo.cpp
+opencv_apps_add_nodelet(corner_harris corner_harris/corner_harris src/nodelet/corner_harris_nodelet.cpp)  # ./tutorial_code/TrackingMotion/cornerHarris_Demo.cpp
   # ./tutorial_code/TrackingMotion/cornerSubPix_Demo.cpp
 
 # videoio
@@ -237,6 +259,7 @@
 # ./em.cpp
 # ./example_cmake/example.cpp
 opencv_apps_add_nodelet(face_detection face_detection/face_detection src/nodelet/face_detection_nodelet.cpp) # ./facedetect.cpp
+opencv_apps_add_nodelet(face_recognition face_recognition/face_recognition src/nodelet/face_recognition_nodelet.cpp)
 # ./facial_features.cpp
 opencv_apps_add_nodelet(fback_flow fback_flow/fback_flow src/nodelet/fback_flow_nodelet.cpp) # ./fback.cpp
 # ./ffilldemo.cpp
@@ -269,35 +292,3 @@
 # ./openni_capture.cpp
 # ./pca.cpp
 opencv_apps_add_nodelet(people_detect people_detect/people_detect src/nodelet/people_detect_nodelet.cpp) # ./peopledetect.cpp
-opencv_apps_add_nodelet(phase_corr phase_corr/phase_corr src/nodelet/phase_corr_nodelet.cpp) # ./phase_corr.cpp
-# ./points_classifier.cpp
-# ./polar_transforms.cpp
-opencv_apps_add_nodelet(segment_objects segment_objects/segment_objects src/nodelet/segment_objects_nodelet.cpp) # ./segment_objects.cpp
-# ./select3dobj.cpp
-# ./shape_example.cpp
-# ./smiledetect.cpp
-# ./squares.cpp
-# ./starter_imagelist.cpp
-# ./starter_video.cpp
-# ./stereo_calib.cpp
-# ./stereo_match.cpp
-# ./stitching.cpp
-# ./stitching_detailed.cpp
-# ./train_HOG.cpp
-# ./train_svmsgd.cpp
-# ./tree_engine.cpp
-# ./tvl1_optical_flow.cpp
-# ./videostab.cpp
-opencv_apps_add_nodelet(watershed_segmentation watershed_segmentation/watershed_segmentation src/nodelet/watershed_segmentation_nodelet.cpp) # ./watershed.cpp
-
-# ros examples
-opencv_apps_add_nodelet(simple_example simple_example/simple_example src/nodelet/simple_example_nodelet.cpp)
-opencv_apps_add_nodelet(simple_compressed_example simple_compressed_example/simple_compressed_example src/nodelet/simple_compressed_example_nodelet.cpp)
-
-# https://github.com/Itseez/opencv/blob/2.4/samples/cpp/simpleflow_demo.cpp
-# simple flow requires opencv-contrib https://github.com/ros-perception/vision_opencv/issues/108
-if(OPENCV_HAVE_OPTFLOW)
-  opencv_apps_add_nodelet(simple_flow simple_flow/simple_flow src/nodelet/simple_flow_nodelet.cpp)
-endif()
-# https://github.com/opencv/opencv/blob/2.4/samples/cpp/bgfg_gmg.cpp
-# https://github.com/opencv/opencv/blob/2.4/samples/cpp/hybridtrackingsample.cpp

=== test/CMakeLists.txt ===
--- 
+++ 
@@ -14,10 +14,23 @@
 add_custom_target(vslam_tutorial_bag DEPENDS ${CMAKE_CURRENT_SOURCE_DIR}/vslam_tutorial.bag)
 add_dependencies(tests vslam_tutorial_bag)
 
+# test data for face recognition
+add_custom_command(OUTPUT ${CMAKE_CURRENT_SOURCE_DIR}/face_data
+  DEPENDS ${CMAKE_CURRENT_SOURCE_DIR}/face_data.tar.gz
+  COMMAND ${CMAKE_COMMAND} -E tar zxf face_data.tar.gz
+  WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}
+  COMMENT "Extracting face_data.tar.gz")
+add_custom_target(face_data DEPENDS ${CMAKE_CURRENT_SOURCE_DIR}/face_data)
+add_dependencies(tests face_data)
+
 #add_rostest(test-apps.test)
 add_rostest(test-adding_images.test ARGS gui:=false)
+add_rostest(test-discrete_fourier_transform.test ARGS gui:=false)
 add_rostest(test-smoothing.test ARGS gui:=false)
 add_rostest(test-threshold.test ARGS gui:=false)
+add_rostest(test-rgb_color_filter.test ARGS gui:=false)
+add_rostest(test-hls_color_filter.test ARGS gui:=false)
+add_rostest(test-hsv_color_filter.test ARGS gui:=false)
 add_rostest(test-edge_detection.test ARGS gui:=false)
 
 add_rostest(test-hough_lines.test ARGS gui:=false)
@@ -26,12 +39,21 @@
 add_rostest(test-convex_hull.test ARGS gui:=false)
 add_rostest(test-general_contours.test ARGS gui:=false)
 add_rostest(test-contour_moments.test ARGS gui:=false)
-if(OpenCV_VERSION VERSION_LESS "3.0")
+if(cv_bridge_VERSION VERSION_LESS "1.11.9") # hydro skip face_detection.test
+elseif(OpenCV_VERSION VERSION_LESS "3.0")
   add_rostest(test-face_detection.test ARGS gui:=false)
+  add_rostest(test-face_recognition.test ARGS gui:=false)
 else()
-  add_rostest(test-face_detection.test ARGS gui:=false use_opencv3:=true)
+  if(OpenCV_VERSION VERSION_LESS "3.2")
+    add_rostest(test-face_detection.test ARGS gui:=false use_opencv3:=true use_opencv3_1:=true)
+    add_rostest(test-face_recognition.test ARGS gui:=false use_opencv3:=true use_opencv3_1:=true)
+  else()
+    add_rostest(test-face_detection.test ARGS gui:=false use_opencv3:=true use_opencv3_2:=true)
+    add_rostest(test-face_recognition.test ARGS gui:=false use_opencv3:=true use_opencv3_2:=true)
+  endif()
 endif()
 add_rostest(test-goodfeature_track.test ARGS gui:=false)
+add_rostest(test-corner_harris.test ARGS gui:=false)
 add_rostest(test-camshift.test ARGS gui:=false)
 add_rostest(test-fback_flow.test ARGS gui:=false)
 add_rostest(test-lk_flow.test ARGS gui:=false)

=== debian/changelog ===
ros-opencv-apps (1.12.0-3build3) focal; urgency=medium

  * No change rebuild against new boost1.71 ABI

 -- Dimitri John Ledkov <xnox@ubuntu.com>  Thu, 06 Feb 2020 11:07:24 +0000

ros-opencv-apps (1.12.0-3build2) focal; urgency=medium

  * No-change rebuild for opencv soname changes.

 -- Matthias Klose <doko@ubuntu.com>  Sun, 02 Feb 2020 07:40:53 +0000

ros-opencv-apps (1.12.0-3build1) focal; urgency=medium

  * No-change rebuild against libopencv-core4.1

 -- Steve Langasek <steve.langasek@ubuntu.com>  Sun, 24 Nov 2019 04:48:55 +0000

ros-opencv-apps (1.12.0-3) unstable; urgency=medium

  * Drop Python 2 package (Closes: #938387)
  * Bump policy version (no changes)
  * switch to debhelper-compat and debhelper 12
  * add Salsa CI
  * Add Patch for OpenCV 4 (Closes: #922591)
  * Drop debian uupdate from d/watch

 -- Jochen Sprickerhof <jspricke@debian.org>  Sun, 20 Oct 2019 23:29:37 +0200

ros-opencv-apps (1.12.0-2) unstable; urgency=medium

  * Add patch for new Opencv 3.4.4 (Closes: #915529)

 -- Jochen Sprickerhof <jspricke@debian.org>  Tue, 11 Dec 2018 08:13:24 +0100

ros-opencv-apps (1.12.0-1) unstable; urgency=medium

  * add Multi-Arch according to hinter
  * Remove common-licenses reference to fix lintian
  * Update d/watch and limit it to ROS1
  * New upstream version 1.12.0
  * Update copyright
  * Bump Soname due to ABI change
  * Update packaging
  * Add Python 3 package

 -- Jochen Sprickerhof <jspricke@debian.org>  Wed, 07 Nov 2018 21:20:43 +0100

=== debian/control ===
Source: ros-opencv-apps
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
Uploaders: Jochen Sprickerhof <jspricke@debian.org>,
           Leopold Palomo-Avellaneda <leo@alaxarxa.net>
Build-Depends: debhelper-compat (= 12), catkin, librosconsole-dev,
		libsensor-msgs-dev, libboost-python-dev, libopencv-dev,
		libdynamic-reconfigure-config-init-mutex-dev, ros-message-generation,
		libimage-transport-dev, libnodeletlib-dev, libroscpp-dev,
		libstd-srvs-dev, dh-python,
		librostest-dev, ros-std-msgs, libcv-bridge-dev,
		ros-sensor-msgs,
		python3-dynamic-reconfigure, python3, python3-roslaunch, 
		python3-rostest, python3-rosunit, python3-rosservice, python3-rosbag,
Standards-Version: 4.4.1
Section: libs
Rules-Requires-Root: no
Homepage: https://wiki.ros.org/opencv_apps
Vcs-Git: https://salsa.debian.org/science-team/ros-opencv-apps.git
Vcs-Browser: https://salsa.debian.org/science-team/ros-opencv-apps

Package: libopencv-apps-dev
Section: libdevel
Architecture: any
Depends: libopencv-apps1d (= ${binary:Version}), ${misc:Depends},
 libcv-bridge-dev, libdynamic-reconfigure-config-init-mutex-dev,
 ros-message-generation, libimage-transport-dev, libnodeletlib-dev,libroscpp-dev
Description: Opencv_apps Robot OS package - development files
 This package is part of Robot OS (ROS). It contains several ROS
 packages for working providing OpenCV functionalities in a simplest
 manner in ROS, i.e., running a launch file that corresponds to
 the functionality.
 .
 The package contains implementations for edge detection, structural analysis,
 people/face detection, motion analysis and object segmentation.
 .
 It contains development files for the opencv_apps library.

Package: libopencv-apps1d
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Multi-Arch: same
Description: opencv_apps Robot OS package - runtime files
 This package is part of Robot OS (ROS). It contains several ROS
 packages for working providing OpenCV functionalities in a simplest
 manner in ROS, i.e., running a launch file that corresponds to
 the functionality.
 .
 The package contains implementations for edge detection, structural analysis,
 people/face detection, motion analysis and object segmentation.
 .
 It contains the opencv_apps library itself.

Package: ros-opencv-apps
Section: utils
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: opencv_apps Robot OS package - apps
 This package is part of Robot OS (ROS). It contains several ROS
 packages for working providing OpenCV functionalities in a simplest
 manner in ROS, i.e., running a launch file that corresponds to
 the functionality.
 .
 The package contains implementations for edge detection, structural analysis,
 people/face detection, motion analysis and object segmentation.
 .
 It contains the nodes and the ROS stuff of the opencv-apps.

Package: python3-opencv-apps
Section: python
Architecture: all
Depends: ${python3:Depends}, ${misc:Depends}, python3-genpy, python3-std-msgs
Description: opencv_apps Robot OS package - Python 3 bindings
 This package is part of Robot OS (ROS). It contains several ROS
 packages for working providing OpenCV functionalities in a simplest
 manner in ROS, i.e., running a launch file that corresponds to
 the functionality.
 .
 The package contains implementations for edge detection, structural analysis,
 people/face detection, motion analysis and object segmentation.
 .
 It contains the Python 3 bindings for the opencv_apps library.

Package: cl-opencv-apps
Section: lisp
Architecture: all
Multi-Arch: foreign
Depends: ${misc:Depends}
Description: opencv_apps Robot OS package - LISP bindings
 This package is part of Robot OS (ROS). It contains several ROS
 packages for working providing OpenCV functionalities in a simplest
 manner in ROS, i.e., running a launch file that corresponds to
 the functionality.
 .
 The package contains implementations for edge detection, structural analysis,
 people/face detection, motion analysis and object segmentation.
 .
 It contains the LISP bindings for the opencv_apps library.

=== debian/rules ===
#!/usr/bin/make -f

export ROS_PYTHON_VERSION=3

%:
	dh $@ --with=python3 --buildsystem=cmake

override_dh_auto_configure:
	dh_auto_configure -- -DCATKIN_ENABLE_TESTING:BOOL=OFF

=== debian/watch ===
version=4
opts="filenamemangle=s%(?:.*?)?v?(\d[\d.]*)\.tar\.gz%@PACKAGE@-$1.tar.gz%" \
    https://github.com/ros-perception/opencv_apps/tags \
    (?:.*?/)?v?(1[\d.]*)\.tar\.gz
